#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>
#include <sys/resource.h>

#define DS_BENCHMARK_DECLS \
	double _ds_benchmark_time_start, _ds_benchmark_time_stop; \
	double _ds_benchmark_time_duration_secs; \
	struct rusage _ds_benchmark_time_ru; \

#define DS_BENCHMARK_START \
	getrusage(RUSAGE_SELF, &_ds_benchmark_time_ru); \
	_ds_benchmark_time_start = (double) _ds_benchmark_time_ru.ru_utime.tv_sec + (double) _ds_benchmark_time_ru.ru_utime.tv_usec * 0.000001;

#define DS_BENCHMARK_STOP \
	getrusage(RUSAGE_SELF, &_ds_benchmark_time_ru); \
	_ds_benchmark_time_stop = (double) _ds_benchmark_time_ru.ru_utime.tv_sec + (double) _ds_benchmark_time_ru.ru_utime.tv_usec*0.000001; \
	_ds_benchmark_time_duration_secs = (double) (_ds_benchmark_time_stop - _ds_benchmark_time_start);

#define DS_BENCHMARK_PRINT(s) \
	fprintf(stderr, \
		    "DS_BENCHMARK: %-20s = %16.9f secs = %16.3f ops/sec\n", \
			(s), \
			_ds_benchmark_time_duration_secs, \
			(double) 1 / _ds_benchmark_time_duration_secs \
	);

#define DS_BENCHMARK_PRINT_AVG(s, n) \
	fprintf(stderr, \
		    "DS_BENCHMARK: %-20s = %16.9f secs = %16.3f ops/sec (average of %i iterations)\n", \
			(s), \
			_ds_benchmark_time_duration_secs / (double) n, \
			(double) n / _ds_benchmark_time_duration_secs, \
			n \
	);
