#ifndef _X2TO1F_H
#define _X2TO1F_H        

struct pub;
struct td;
struct elemA;
struct elemB;

int TdGen(struct pub **pub, struct td **td, int bits);
void pub_release(struct pub *pub);
void td_release(struct td *td);

size_t get_sample_seed_len_A(const struct pub *pub);
size_t get_sample_seed_len_B(const struct pub *pub);
size_t get_storage_size_A(const struct pub *pub);
size_t get_storage_size_B(const struct pub *pub);

struct elemA* SampleAFromSeed(const struct pub *pub, const void *seed);
struct elemA* SampleA0FromSeed(const struct pub *pub, const void *seed);
struct elemA* SampleA1FromSeed(const struct pub *pub, const void *seed);
struct elemB* SampleBFromSeed(const struct pub *pub, const void *seed);

struct elemB* Apply(const struct pub *pub, const struct elemA *a);
struct elemA* Reverse(const struct td *td, const struct pub *pub, const struct elemB *b, int d);
int Decide(const struct pub *pub, const struct elemA *a);
struct td* Extract(const struct pub *pub, const struct elemA *a0, const struct elemA *a1);

void elemA_export(const struct pub *pub, const struct elemA *a, void *buf);
void elemB_export(const struct pub *pub, const struct elemB *b, void *buf);

struct elemA* elemA_import(const struct pub *pub, const void *buf);
struct elemB* elemB_import(const struct pub *pub, const void *buf);

int elemA_equal(const struct elemA *a1, const struct elemA *a2);
int elemB_equal(const struct elemB *b1, const struct elemB *b2);

void elemA_release(struct elemA *a);
void elemB_release(struct elemB *b);

#endif  /* _X2TO1F_H */
